// API_ODBCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "API_ODBC.h"
#include "API_ODBCDlg.h"
#include ".\api_odbcdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

struct RECORD
{
	int recNumEdit;//     /
	CString recNameEdit;//    
	int recYearEdit;//    
};

#define LEN_BUF 31 //  

// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// CAPI_ODBCDlg dialog
CAPI_ODBCDlg::CAPI_ODBCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAPI_ODBCDlg::IDD, pParent)
	, m_NumEdit(0)
	, m_NameEdit(_T(""))
	, m_YearEdit(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAPI_ODBCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LISTBOX, m_ListBox);
	DDX_Text(pDX, IDC_NUMEDIT, m_NumEdit);
	DDX_Text(pDX, IDC_NAMEEDIT, m_NameEdit);
	DDX_Text(pDX, IDC_YEAREDIT, m_YearEdit);
}

BEGIN_MESSAGE_MAP(CAPI_ODBCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_LBN_SELCHANGE(IDC_LISTBOX, OnLbnSelchangeListbox)
END_MESSAGE_MAP()


// CAPI_ODBCDlg message handlers

BOOL CAPI_ODBCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	FillDbToListBox();
	m_ListBox.SetCurSel(0);
	OnLbnSelchangeListbox();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAPI_ODBCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAPI_ODBCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAPI_ODBCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//     DB
void CAPI_ODBCDlg::FillDbToListBox(void)
{
//     
	SQLHENV henv = NULL;
	SQLHDBC hdbc = NULL;
	SQLHSTMT hstmt = NULL;
	bool bIsConnected = false;
	SQLRETURN rc;

//   ODBC 
	rc = SQLAllocHandle(SQL_HANDLE_ENV,
                              SQL_NULL_HANDLE,
                              &henv);
	if(rc != SQL_SUCCESS){
		MessageBox("   ODBC",
				   "", MB_OK | MB_ICONSTOP);
		return;
	}

//   ODBC-3
	rc = SQLSetEnvAttr(henv,
				SQL_ATTR_ODBC_VERSION,
				(SQLPOINTER) SQL_OV_ODBC3,
				SQL_IS_INTEGER);
	if(rc != SQL_SUCCESS){
		MessageBox("    ODBC",
				   "", MB_OK | MB_ICONSTOP);
		return;
	}

//   ODBC     
	rc = SQLAllocHandle(SQL_HANDLE_DBC, henv, &hdbc);
	if(rc != SQL_SUCCESS){
		MessageBox("      ",
				   "", MB_OK | MB_ICONSTOP);
		return;
	}

//     
	rc = SQLConnect(hdbc, //  
          (SQLCHAR*) "MyBase", SQL_NTS, // DSN
          (SQLCHAR*) "", SQL_NTS, //  
          (SQLCHAR*) "", SQL_NTS); //   
	if(rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO){
		MessageBox("     ",
				   "", MB_OK | MB_ICONSTOP);
		return;
	}
	bIsConnected = true; //  ,   

//    (statement handle)
//    SQL- 
	rc = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt);
	if(rc != SQL_SUCCESS){
		MessageBox("    ",
				   "", MB_OK | MB_ICONSTOP);
		return;
	}

//    SQL- (    )
	LPCSTR szSQL = "SELECT number, name, birth FROM MyTable.dbf";
	rc = SQLExecDirect(hstmt, (unsigned char*)szSQL, SQL_NTS);
	if(rc != SQL_SUCCESS){
		MessageBox("   SQL-  ",
				   "", MB_OK | MB_ICONSTOP);
		return;
	}

//     
	long int cb; //   SDWORD
	int iNumber; 
	char strName[LEN_BUF];
	int iBirth; 
	SQLBindCol(hstmt, 1, SQL_INTEGER, &iNumber, 0, &cb);// Field1
	SQLBindCol(hstmt, 2, SQL_CHAR, strName, LEN_BUF, &cb);// Field2
	SQLBindCol(hstmt, 3, SQL_INTEGER, &iBirth, 0, &cb);// Field3

//  
	rc = SQLFetch(hstmt);
	while(rc == SQL_SUCCESS){
		RECORD* pRecord = new RECORD;
		pRecord->recNumEdit = iNumber;
		pRecord->recNameEdit = strName;
		pRecord->recYearEdit = iBirth;
		CString strTerm;
		strTerm.Format("%d    %s    %d", iNumber, strName, iBirth);
		int iIndex = m_ListBox.AddString(strTerm);//   
		//        
		m_ListBox.SetItemData(iIndex, (DWORD_PTR)pRecord);
		                
		rc = SQLFetch(hstmt); //   
	}
	
//    ODBC
	if(henv){
		if(hdbc){
			if(bIsConnected){
				if(hstmt){
					SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
				}
				SQLDisconnect(hdbc);
				bIsConnected = false;
			}
			SQLFreeHandle(SQL_HANDLE_DBC, hdbc);
			hdbc = NULL;
		}
		SQLFreeHandle(SQL_HANDLE_ENV, henv);
		henv = NULL;
	}
}

BOOL CAPI_ODBCDlg::DestroyWindow()
{
	RECORD* pRecord;
	int nCount = m_ListBox.GetCount();
	for(int i = 0; i < nCount; i++){
		pRecord = (RECORD*)m_ListBox.GetItemData(i);
		if(pRecord)
			delete pRecord;
	}

	return CDialog::DestroyWindow();
}

void CAPI_ODBCDlg::OnLbnSelchangeListbox()
{
	int iIndex = m_ListBox.GetCurSel();
	if(iIndex == LB_ERR) return;

	RECORD* pRecord = 
               (RECORD*)m_ListBox.GetItemData(iIndex);
	if(pRecord){
		m_NumEdit = pRecord->recNumEdit;
		m_NameEdit = pRecord->recNameEdit;
		m_YearEdit = pRecord->recYearEdit;

		UpdateData(FALSE);
	}
}
